package com.casic.dcms.mvp.model;

import com.casic.dcms.bean.ActionResultBean;
import com.casic.dcms.utils.retrofit.RetrofitServiceManager;

import rx.Observable;
import rx.Observer;
import rx.Subscription;
import rx.android.schedulers.AndroidSchedulers;
import rx.schedulers.Schedulers;

public class PushRegisterModelImpl implements IPushRegisterModel {

    private OnRegisterListener updateListener;

    public PushRegisterModelImpl(OnRegisterListener listener) {
        this.updateListener = listener;
    }

    public interface OnRegisterListener {
        void onSuccess(ActionResultBean resultBean);

        void onFailure(Throwable throwable);
    }

    @Override
    public Subscription sendRetrofitRequest(String clientid) {
        Observable<ActionResultBean> observable = RetrofitServiceManager.getRegisterResult(clientid);
        return observable.subscribeOn(Schedulers.io()).observeOn(AndroidSchedulers.mainThread()).subscribe(new Observer<ActionResultBean>() {
            @Override
            public void onCompleted() {

            }

            @Override
            public void onError(Throwable e) {
                if (e.getCause() != null) {
                    updateListener.onFailure(e);
                }
            }

            @Override
            public void onNext(ActionResultBean resultBean) {
                if (resultBean != null) {
                    updateListener.onSuccess(resultBean);
                }
            }
        });
    }
}
